MersenneTwister< K, M, N, F, S > Class Template Reference

Mersenne Twister class for Monte-Carlo simulations. More...

Inheritance diagram for MersenneTwister< K, M, N, F, S >:

## Public Member Functions

| MersenneTwister (unsigned long seed=S)
| Construct a Mersenne Twister. More...
void | GenerateBlock (byte *output, size_t size)
| Generate random array of bytes. More...
word32 | GenerateWord32 (word32 min=0, word32 max=0xffffffffL)
| Generate a random 32-bit word in the range min to max, inclusive. More...
void | DiscardBytes (size_t n)
| Generate and discard n bytes. More...
Public Member Functions inherited from RandomNumberGenerator
virtual void | IncorporateEntropy (const byte *input, size_t length)
| Update RNG state with additional unpredictable values. More...
virtual bool | CanIncorporateEntropy () const
| Determines if a generator can accept additional entropy. More...
virtual byte | GenerateByte ()
| Generate new random byte and return it. More...
virtual unsigned int | GenerateBit ()
| Generate new random bit and return it. More...
virtual void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword length)
| Generate random bytes into a BufferedTransformation. More...
template<class IT >
void | Shuffle (IT begin, IT end)
| Randomly shuffle the specified array. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Detailed Description

### template<unsigned int K, unsigned int M, unsigned int N, unsigned int F, unsigned long S>
class MersenneTwister< K, M, N, F, S >

Mersenne Twister class for Monte-Carlo simulations.

Template Parameters

  K | Magic constant
  M | Period parameter
  N | Size of the state vector
  F | Multiplier constant
  S | Initial seed

Provides the MersenneTwister implementation. The class is a header-only implementation.

Warning
  MersenneTwister is suitable for simulations, where uniformaly distrubuted numbers are required quickly. It should not be used for cryptographic purposes.

See also
  MT19937, MT19937ar

Since
  Crypto++ 5.6.3

Definition at line 31 of file mersenne.h.

## Constructor & Destructor Documentation

## MersenneTwister()

template<unsigned int K, unsigned int M, unsigned int N, unsigned int F, unsigned long S>

MersenneTwister< K, M, N, F, S >::MersenneTwister | ( | unsigned long | seed = `S` | ) |

inline

Construct a Mersenne Twister.

Parameters

  seed | 32-bit seed

Defaults to template parameter S due to changing algorithm parameters over time

Definition at line 38 of file mersenne.h.

## Member Function Documentation

## GenerateBlock()

template<unsigned int K, unsigned int M, unsigned int N, unsigned int F, unsigned long S>

void MersenneTwister< K, M, N, F, S >::GenerateBlock | ( | byte * | output,
|  | size_t | size
| ) |  |

inline virtual

Generate random array of bytes.

Parameters

  output | byte buffer
  size | length of the buffer, in bytes

Bytes are written to output in big endian order. If output length is not a multiple of word32, then unused bytes are not accumulated for subsequent calls to GenerateBlock. Rather, the unused tail bytes are discarded, and the stream is continued at the next word32 boundary from the state array.

Reimplemented from RandomNumberGenerator.

Definition at line 52 of file mersenne.h.

## GenerateWord32()

template<unsigned int K, unsigned int M, unsigned int N, unsigned int F, unsigned long S>

word32 MersenneTwister< K, M, N, F, S >::GenerateWord32 | ( | word32 | min = `0`,
|  | word32 | max = `0xffffffffL`
| ) |  |

inline virtual

Generate a random 32-bit word in the range min to max, inclusive.

Returns
  random 32-bit word in the range min to max, inclusive

If the 32-bit candidate is not within the range, then it is discarded and a new candidate is used.

Reimplemented from RandomNumberGenerator.

Definition at line 98 of file mersenne.h.

## DiscardBytes()

template<unsigned int K, unsigned int M, unsigned int N, unsigned int F, unsigned long S>

void MersenneTwister< K, M, N, F, S >::DiscardBytes | ( | size_t | n | ) |

inline virtual

Generate and discard n bytes.

Parameters

  n | the number of bytes to discard, rounded up to a `word32` size

If n is not a multiple of `word32`, then unused bytes are not accumulated for subsequent calls to GenerateBlock. Rather, the unused tail bytes are discarded, and the stream is continued at the next `word32` boundary from the state array.

Reimplemented from RandomNumberGenerator.

Definition at line 120 of file mersenne.h.

The documentation for this class was generated from the following file:

- mersenne.h